#include <string.h>

#include "cStr.h"

MyString::MyString() : c_string_(nullptr) {}

MyString::MyString(const char* a_c_string) : c_string_(nullptr) {
    Set(a_c_string);
}

MyString::MyString(const MyString& str) : c_string_(nullptr) {
    Set(str.c_string_);
}

MyString::~MyString() {
    delete[] c_string_;
}

const char* MyString::c_string() const {
    return c_string_;
}

size_t MyString::Length() const {
    return c_string_ == nullptr ? 0 : strlen(c_string_);
}

const char* MyString::CloneCString(const char* a_c_string) {
    if (a_c_string == nullptr)
        return nullptr;

    const size_t len = strlen(a_c_string);
    char* const clone = new char[len + 1];
    memcpy(clone, a_c_string, len + 1);

    return clone;
}

void MyString::Set(const char* a_c_string) {
    const char* const temp = MyString::CloneCString(a_c_string);
    delete[] c_string_;
    c_string_ = temp;
}

